# 2020-07-29: 
# added explanation for width and instruction for slides in different axis
# made able to start slide from any point in the water (makes acceleration effect partially lost)
# changed area where tag and armor stand are set to have the same width as the other areas and made check radius for existing armor stand bigger
# changed the areas for commands at the end of the slide and added instruction for the one that kills the armor stand
# changed check for player inside water so that the slide start only if the player is submerged with half their body

# 2020-08-02
# This command will make sure sliding entities, players excluded, will face the slide constantly
# Change the command according to the axis your slides are in, but you can also choose to remove it.
execute as @e[tag=sliding,type=!player] at @s run tp @s ~ ~ ~ -90 ~

# 2020-08-02
# This command makes sure that there can't be any armor stand if there are no entity sliding (safety measure)
execute unless entity @e[tag=sliding] run kill @e[tag=water_slide]

# For your own slides, you will have to change the areas where these commands take effect. You will have to change:
# The area where the slides start (x=191,y=90,z=326,dx=0,dy=1,dz=14)
# The areas of the slides themselves, decreasing in height (x=190,y=71,z=326,dx=31,dy=19,dz=14)
# The area at the end of the slide (x=223.2,y=67,z=326,dx=2,dy=0.4,dz=14)
# Take close attention to the relations between the areas of this function: they have to be the same for yours.

# If your slides are oriented in the z axis, change the areas and the teleport commands accordingly.

# In this example, the areas where the commands have effect is enough wide (dz is bigger than a single slide's width) to include three slides
# You can make dz (or dx if the slides are in the other axis) wider or narrower to include more or less slides
# If you put slides in different places distant from each other, it might be better the replicate the commands for each place.

# When an entity stands in the water of a slide, a tag is applied to them and an armor stand is spawned: entities with the tag will be teleported to this stand.
execute as @e[x=191,y=71,z=326,dx=31,dy=20,dz=14] at @s if block ~ ~0.9 ~ water unless entity @e[tag=water_slide,distance=..2] run tag @s add sliding
execute as @e[x=191,y=71,z=326,dx=31,dy=20,dz=14] at @s if block ~ ~0.9 ~ water unless entity @e[tag=water_slide,distance=..2] run summon armor_stand ~ ~ ~ {Marker:true,Invisible:true,Tags:["water_slide"]}
execute as @e at @s unless entity @e[tag=water_slide] run tag @s remove sliding

# Only the nearest entity will be teleported to the stand, allowing multiple sliding entities
execute as @e[tag=water_slide] at @s run tp @e[tag=sliding,limit=1,sort=nearest] ~ ~ ~

# These commands teleport forward the stand, increasing its speed during the slide
execute as @e[tag=water_slide,x=190,y=71,z=326,dx=31,dy=20,dz=14] at @s if block ~ ~ ~ water run tp @s ~0.1 ~ ~
execute as @e[tag=water_slide,x=190,y=71,z=326,dx=31,dy=18,dz=14] at @s if block ~ ~ ~ water run tp @s ~0.06 ~ ~
execute as @e[tag=water_slide,x=190,y=71,z=326,dx=31,dy=15,dz=14] at @s if block ~ ~ ~ water run tp @s ~0.14 ~ ~
execute as @e[tag=water_slide,x=190,y=71,z=326,dx=31,dy=10,dz=14] at @s if block ~ ~ ~ water run tp @s ~0.35 ~ ~
execute as @e[tag=water_slide,x=190,y=71,z=326,dx=31,dy=6,dz=14] at @s if block ~ ~ ~ water run tp @s ~0.7 ~ ~
# These commands will teleport the stand downwards to keep the entities inside the water
execute as @e[tag=water_slide,x=192,y=70,z=326,dx=33,dy=21,dz=14] at @s if block ~ ~0.3 ~ air run tp @s ~0.11 ~-0.3 ~
execute as @e[tag=water_slide,x=221,y=67,z=326,dx=4,dy=22,dz=14] at @s run tp @s ~0.15 ~-0.4 ~

# At the end of the slide, a splash effect is applied
execute as @e[tag=water_slide,x=223.2,y=67,z=326,dx=2,dy=0.4,dz=14] at @s run particle splash ~ ~1.8 ~ 0.4 0.4 0.4 0.5 500 force

# At the end of the slide, the stand is killed
# To set the area of effect right correctly, it will take a bit of trial and error; test it also by trying to climb the end of the slide to see if the armor stand is killed
kill @e[tag=water_slide,x=222.2,y=66,z=326,dx=3,dy=1,dz=14]


# This data pack can be used freely; if you do intend to use this data pack for a custom map, you have to credit the creator, PmkExpert, in a visible way.
# Contact on Reddit for any question: https://www.reddit.com/user/Pmk23